<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>eRPC API Reference: erpc::Transport Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<link href="customdoxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eRPC API Reference
   &#160;<span id="projectnumber">Rev. 1.4.0</span>
   </div>
   <div id="projectbrief">NXP Semiconductors</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>API&#160;Reference</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classerpc_1_1_transport.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classerpc_1_1_transport-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">erpc::Transport Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span><div class="ingroups"><a class="el" href="group__infra.html">Infrastructure</a> &raquo; <a class="el" href="group__infra__transport.html">Transports</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>Abstract interface for transport layer.  
 <a href="classerpc_1_1_transport.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="transport_8h_source.html">transport.h</a>&gt;</code></p>
<div id="dynsection-0" onclick="return toggleVisibility(this)" class="dynheader closed" style="cursor:pointer;">
  <img id="dynsection-0-trigger" src="closed.png" alt="+"/> Inheritance diagram for erpc::Transport:</div>
<div id="dynsection-0-summary" class="dynsummary" style="display:block;">
</div>
<div id="dynsection-0-content" class="dyncontent" style="display:none;">
<div class="center"><iframe scrolling="no" frameborder="0" src="classerpc_1_1_transport__inherit__graph.svg" width="626" height="443"><p><b>This browser is not able to show SVG: try Firefox, Chrome, Safari, or Opera instead.</b></p></iframe>
</div>
<center><span class="legend">[<a target="top" href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a895a468f9810eba023c68197edefb301"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a895a468f9810eba023c68197edefb301"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpc_1_1_transport.html#a895a468f9810eba023c68197edefb301">Transport</a> ()</td></tr>
<tr class="memdesc:a895a468f9810eba023c68197edefb301"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor. <br /></td></tr>
<tr class="separator:a895a468f9810eba023c68197edefb301"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac75843918e2fbe211430cf5973caac47"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac75843918e2fbe211430cf5973caac47"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpc_1_1_transport.html#ac75843918e2fbe211430cf5973caac47">~Transport</a> ()</td></tr>
<tr class="memdesc:ac75843918e2fbe211430cf5973caac47"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="classerpc_1_1_transport.html" title="Abstract interface for transport layer. ">Transport</a> destructor. <br /></td></tr>
<tr class="separator:ac75843918e2fbe211430cf5973caac47"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3f886733620e1a2fe00d12f36711dde5"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__infra.html#ga5f8872e58f09a16d192bf664f9898651">erpc_status_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpc_1_1_transport.html#a3f886733620e1a2fe00d12f36711dde5">receive</a> (<a class="el" href="classerpc_1_1_message_buffer.html">MessageBuffer</a> *message)=0</td></tr>
<tr class="memdesc:a3f886733620e1a2fe00d12f36711dde5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prototype for receiving message.  <a href="#a3f886733620e1a2fe00d12f36711dde5">More...</a><br /></td></tr>
<tr class="separator:a3f886733620e1a2fe00d12f36711dde5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4ede71b16625cba746818294148f9aba"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__infra.html#ga5f8872e58f09a16d192bf664f9898651">erpc_status_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpc_1_1_transport.html#a4ede71b16625cba746818294148f9aba">send</a> (<a class="el" href="classerpc_1_1_message_buffer.html">MessageBuffer</a> *message)=0</td></tr>
<tr class="memdesc:a4ede71b16625cba746818294148f9aba"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prototype for send message.  <a href="#a4ede71b16625cba746818294148f9aba">More...</a><br /></td></tr>
<tr class="separator:a4ede71b16625cba746818294148f9aba"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abee09d5af8f4a38ae83891afc6472066"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpc_1_1_transport.html#abee09d5af8f4a38ae83891afc6472066">hasMessage</a> ()</td></tr>
<tr class="memdesc:abee09d5af8f4a38ae83891afc6472066"><td class="mdescLeft">&#160;</td><td class="mdescRight">Poll for an incoming message.  <a href="#abee09d5af8f4a38ae83891afc6472066">More...</a><br /></td></tr>
<tr class="separator:abee09d5af8f4a38ae83891afc6472066"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Abstract interface for transport layer. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a3f886733620e1a2fe00d12f36711dde5"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="group__infra.html#ga5f8872e58f09a16d192bf664f9898651">erpc_status_t</a> erpc::Transport::receive </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classerpc_1_1_message_buffer.html">MessageBuffer</a> *&#160;</td>
          <td class="paramname"><em>message</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Prototype for receiving message. </p>
<p>Each transport layer need define this function.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[out]</td><td class="paramname">message</td><td>Will return pointer to received message buffer.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>based on receive implementation. </dd></dl>

<p>Implemented in <a class="el" href="classerpc_1_1_r_p_msg_z_c_transport.html#a6b546b63b1ebca13292073a19028d582">erpc::RPMsgZCTransport</a>, <a class="el" href="classerpc_1_1_r_p_msg_z_c_r_t_o_s_transport.html#a96e5732fce51c62826ebecb867a8c760">erpc::RPMsgZCRTOSTransport</a>, <a class="el" href="classerpc_1_1_framed_transport.html#a206f88e12844d6650c1611eefbec2fe3">erpc::FramedTransport</a>, <a class="el" href="classerpc_1_1_inter_thread_buffer_transport.html#afc8619a2b970c2c5fbdfa7e464b2fbf4">erpc::InterThreadBufferTransport</a>, and <a class="el" href="classerpc_1_1_transport_arbitrator.html#a57178dc83b44f3147edf84560ada7650">erpc::TransportArbitrator</a>.</p>

</div>
</div>
<a class="anchor" id="a4ede71b16625cba746818294148f9aba"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="group__infra.html#ga5f8872e58f09a16d192bf664f9898651">erpc_status_t</a> erpc::Transport::send </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classerpc_1_1_message_buffer.html">MessageBuffer</a> *&#160;</td>
          <td class="paramname"><em>message</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Prototype for send message. </p>
<p>Each transport layer need define this function.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">message</td><td>Pass message buffer to send.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>based on send implementation. </dd></dl>

<p>Implemented in <a class="el" href="classerpc_1_1_r_p_msg_z_c_transport.html#a56b5c6625b0455e984168eb9e462ffca">erpc::RPMsgZCTransport</a>, <a class="el" href="classerpc_1_1_r_p_msg_z_c_r_t_o_s_transport.html#a1ac14738de5b8b1b730cb5ec4cb82e38">erpc::RPMsgZCRTOSTransport</a>, <a class="el" href="classerpc_1_1_framed_transport.html#afe8eaf84d24d64ce7515c6d9fe6c5085">erpc::FramedTransport</a>, and <a class="el" href="classerpc_1_1_transport_arbitrator.html#afceb02fe214a1e64856b458e701c6390">erpc::TransportArbitrator</a>.</p>

</div>
</div>
<a class="anchor" id="abee09d5af8f4a38ae83891afc6472066"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool erpc::Transport::hasMessage </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Poll for an incoming message. </p>
<p>This function should return true if are some messages to process by server, the return value should be tested before calling receive function to avoid waiting for a new message (receive can be implemented as blocking function).</p>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">True</td><td>when a message is available to process, else false. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="classerpc_1_1_r_p_msg_z_c_transport.html#a2c1bd3cffafd775330f03a1d1fb51894">erpc::RPMsgZCTransport</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="transport_8h_source.html">transport.h</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- HTML footer for doxygen 1.8.5-->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul class="foot">
    <li class="footer">&copy; 2016 NXP Semiconductors. All rights reserved.
    </li>
  </ul>
</div>
</body>
</html>
